/* $USAGI: ipsec6_algos.h,v 1.3 2001/08/15 06:34:23 mk Exp $ */
#ifndef _IPSEC6_ALGOS_H
#define _IPSEC6_ALGOS_H

#define IPSEC_NAME_LEN 10

#ifdef __KERNEL__

typedef void (encrypt_data_t)(char* data, int data_size, char* iv, 	
	char* key, char* result, int result_size);

struct ipsec_enc_t {
	char name[IPSEC_NAME_LEN+1];
	int key_size; /* Key size in bytes */
	int iv_size; /* Size of initialization vector */
	int block_size; /* Block size of algorithm gives upper boundary for padding size */
	encrypt_data_t *encrypt_data;
	encrypt_data_t *decrypt_data;
};

typedef void (calc_hash_t)(char* data, int data_size, char* key, char* result);

struct ipsec_hash_t {
	char name[IPSEC_NAME_LEN+1];
	int key_size; /* Key size in bytes */
	int hash_size;  /* Size of authentication data in AH (in bytes) */
	calc_hash_t *calc_hash;
};


/* Hash sizes are supposed to be a multiple of 8 bytes in size. */

extern int ipsec_register_enc(u_int8_t no, char* name, int key_size,
	int iv_size, int block_size, encrypt_data_t *encrypt_data,
	encrypt_data_t *decrypt_data);
extern void ipsec_unregister_enc(u_int8_t no);
extern int ipsec_register_hash(u_int8_t no, char* name, int key_size,
	int hash_size, calc_hash_t *calc_hash);
extern void ipsec_unregister_hash(u_int8_t no);

#ifndef ALGOSMOD
extern int algos_init(void);
extern void algos_cleanup(void);
#endif /* ALGOSMOD */

#endif /* __KERNEL__ */
#endif
